//************************************************************************
// 	TEST.CPP
//************************************************************************
//
//  Purpose:	Test prog for hierarchical listbox
//
//  Author:	Vogel Andreas, CIS:100343,2704
//

#include "hierbox.h"

#include <owl\statusba.h>
#include <owl\applicat.h>
#include <owl\decframe.h>
#include <owl\dialog.h>
#include <owl\checkbox.h>

#include "hierdlg.rc"


//-------------------------------------------------------- defines -------

#define WINDOWTITLE "HIERDLG Test"

//-------------------------------------------------------- globals -------
//------------------------------------------------------ externals -------
//--------------------------------------------- external functions -------
//------------------------------------------------ local functions -------
//-------------------------------------------------------- statics -------



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

class THDialog : public cHierDialog

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// test dialog with resource bitmaps
{
  TCheckBox	*CheckBox;

public:
	THDialog(TWindow *, TResID);

  //overloaded:
  void	SetupWindow();

  void	CmListBox();
  void	CmSelChangeBox();

DECLARE_RESPONSE_TABLE(THDialog);
};

DEFINE_RESPONSE_TABLE1(THDialog, cHierDialog)
  EV_LBN_DBLCLK(	ID_LISTBOX, 	CmListBox),
  EV_LBN_SELCHANGE(	ID_LISTBOX, 	CmSelChangeBox),
END_RESPONSE_TABLE;

//------------------------------------------------------------------------
void 	THDialog::CmListBox()
//------------------------------------------------------------------------
//  Action on item ...
{
  if (ListBox->Action())
    MessageBox("Do something with this", "Simon Says", MB_OK);
}

//------------------------------------------------------------------------
void 	THDialog::CmSelChangeBox()
//------------------------------------------------------------------------
//  another item selected
{
  char	hstr[80];
  int 	idx = ListBox->GetSelIndex();

  ListBox->GetSelString(hstr, 80);

  // get index to array created with <AddItem()>
  int	cidx = ListBox->GetContentSelIndex();

  SetDlgItemText(IDC_SELITEM, hstr);

  DWORD dw = ListBox->GetItemData(idx);

  CheckBox->SetCheck( (dw & 1) ? TRUE : FALSE);
}

//------------------------------------------------------------------------
	THDialog::THDialog(TWindow *Parent, TResID Id) :
		cHierDialog(Parent, Id)
//------------------------------------------------------------------------
{
  ListBox = new cHierListBox(this,
			    ID_LISTBOX,
			    LISTBOXICONS,
			    4, 3);

  CheckBox = new TCheckBox(this, IDC_SELECTABLE, NULL);
}

//------------------------------------------------------------------------
void	THDialog::SetupWindow()
//------------------------------------------------------------------------
{
  cHierDialog::SetupWindow();

  ListBox->AddItem("item-0-0-0-0" , 		0 );
    ListBox->AddItem("item-0-0-0-1" , 		1 );
    ListBox->AddItem("item-0-0-0-2" , 		1 );
    ListBox->AddItem("item-0-0-0-3" , 		1 );
    ListBox->AddItem("item-0-0-0-4" , 		1 );

  ListBox->AddItem("item-0-0-0-0" , 		0, 1 );  // foldup !
    ListBox->AddItem("item-0-1-0-0" , 		1 );
    ListBox->AddItem("item-0-2-0-0" , 		1 );
      ListBox->AddItem("item-0-2-0-0" , 	2 );
      ListBox->AddItem("item-0-2-1-0" , 	2 );
      ListBox->AddItem("item-0-2-2-0" , 	2 );
	ListBox->AddItem("item-0-2-2-0" , 	3 );
	  ListBox->AddItem("item-9-2-2-1" , 	4 );
	  ListBox->AddItem("item-9-2-2-2" , 	4 );
	  ListBox->AddItem("item-9-2-2-3" , 	4 );
	  ListBox->AddItem("item-9-2-2-4" , 	4 );
	ListBox->AddItem("item-0-2-2-1" , 	3 );
	ListBox->AddItem("item-0-2-2-2" , 	3 );
	ListBox->AddItem("item-0-2-2-3" , 	3 );
	ListBox->AddItem("item-0-2-2-4" , 	3 );
      ListBox->AddItem("item-0-2-3-0" , 	2 );
    ListBox->AddItem("item-0-3-0-0" , 		1 );
    ListBox->AddItem("item-0-4-0-0" , 		1 );
      ListBox->AddItem("item-0-4-0-0" , 	2 );
      ListBox->AddItem("item-0-4-1-0" , 	2 );
      ListBox->AddItem("item-0-4-2-0" , 	2 );
      ListBox->AddItem("item-0-4-3-0" , 	2 );
	ListBox->AddItem("item-0-4-3-0" , 	3 );
	ListBox->AddItem("item-0-4-3-1" , 	3 );
	ListBox->AddItem("item-0-4-3-2" , 	3 );
	ListBox->AddItem("item-0-4-3-3" , 	3 );
    ListBox->AddItem("item-0-5-0-0" , 		1 );

  ListBox->AddItem("item-1-0-0-0" , 		0 );
    ListBox->AddItem("item-1-1-0-0" , 		1 );
    ListBox->AddItem("item-1-2-0-0" , 		1 );
      ListBox->AddItem("item-1-2-0-0" , 	2 );
      ListBox->AddItem("item-1-2-1-0" , 	2 );
      ListBox->AddItem("item-1-2-2-0" , 	2 );
	ListBox->AddItem("item-1-2-2-0" , 	3 );
	ListBox->AddItem("item-1-2-2-1" , 	3 );
	ListBox->AddItem("item-1-2-2-2" , 	3 );
	ListBox->AddItem("item-1-2-2-3" , 	3 );
	ListBox->AddItem("item-1-2-2-4" , 	3 );
      ListBox->AddItem("item-1-2-3-0" , 	2 );
    ListBox->AddItem("item-1-3-0-0" , 		1 );
    ListBox->AddItem("item-1-4-0-0" , 		1 );
      ListBox->AddItem("item-1-4-0-0" , 	2 );
      ListBox->AddItem("item-1-4-1-0" , 	2 );
      ListBox->AddItem("item-1-4-2-0" , 	2 );
      ListBox->AddItem("item-1-4-3-0" , 	2 );
	ListBox->AddItem("item-1-4-3-0" , 	3 );
	ListBox->AddItem("item-1-4-3-1" , 	3 );
	ListBox->AddItem("item-1-4-3-2" , 	3 );
	ListBox->AddItem("item-1-4-3-3" , 	3 );
    ListBox->AddItem("item-1-5-0-0" , 		1 );
    ListBox->AddItem("item-1-6-0-0" , 		1 );

  ListBox->AddItem("item-2-0-0-0" , 		0 );
  ListBox->AddItem("item-3-0-0-0" , 		0 );
  ListBox->AddItem("item-4-0-0-0" , 		0 );
  ListBox->AddItem("item-5-0-0-0" , 		0 );
  ListBox->AddItem("item-6-0-0-0" , 		0 );

  ListBox->SetupItemData();
}



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

class TH1Dialog : public cHierDialog

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// test dialog with external bitmaps
{
  TCheckBox	*CheckBox;

public:
	TH1Dialog(TWindow *, TResID);

  //overloaded:
  void	SetupWindow();

  //message:
  void	CmListBox();
  void	CmSelChangeBox();

  //user:

DECLARE_RESPONSE_TABLE(TH1Dialog);
};

DEFINE_RESPONSE_TABLE1(TH1Dialog, cHierDialog)
  EV_LBN_DBLCLK(	ID_LISTBOX, 	CmListBox),
  EV_LBN_SELCHANGE(	ID_LISTBOX, 	CmSelChangeBox),
END_RESPONSE_TABLE;

//------------------------------------------------------------------------
void 	TH1Dialog::CmListBox()
//------------------------------------------------------------------------
//  Action on item ...
{
  if (ListBox->Action())
    MessageBox("Do something with this", "Simon Says", MB_OK);
}

//------------------------------------------------------------------------
void 	TH1Dialog::CmSelChangeBox()
//------------------------------------------------------------------------
//  another item selected
{
  char	hstr[80];
  int 	idx = ListBox->GetSelIndex();

  ListBox->GetSelString(hstr, 80);

  // get index to array created with <AddItem()>
  int	cidx = ListBox->GetContentSelIndex();

  SetDlgItemText(IDC_SELITEM, hstr);

  DWORD dw = ListBox->GetItemData(idx);

  CheckBox->SetCheck( (dw & 1) ? TRUE : FALSE);
}

//------------------------------------------------------------------------
	TH1Dialog::TH1Dialog(TWindow *Parent, TResID Id) :
		cHierDialog(Parent, Id)
//------------------------------------------------------------------------
{
  ListBox = new cHierListBox(this,
			    ID_LISTBOX,
			    "default.bmp");

  CheckBox = new TCheckBox(this, IDC_SELECTABLE, NULL);
}

//------------------------------------------------------------------------
void	TH1Dialog::SetupWindow()
//------------------------------------------------------------------------
{
  cHierDialog::SetupWindow();

  ListBox->AddItem("sub1.bmp", "item-2-0-0-0 (more)" , 		0 );
    ListBox->AddItem("buggy.bmp", "item-2-0-0-1" , 		1 );
    ListBox->AddItem("sub2.bmp", "item-2-1-0-1" , 		1 );
    ListBox->AddItem("sub2.bmp", "item-2-3-0-1 (more)" ,	1 );
    ListBox->AddItem("buggy.bmp", "item-2-0-0-2" , 		2 );
    ListBox->AddItem("sub2.bmp", "item-2-0-1-2 (more)" ,	2 );
    ListBox->AddItem("sub2.bmp", "item-2-0-0-3" , 		3 );
    ListBox->AddItem("sub2.bmp", "item-2-0-1-3" , 		3 );

  ListBox->AddItem("sub1.bmp", "item-2-0-0-0 (more)" , 		0 );
    ListBox->AddItem("buggy.bmp", "item-2-0-0-1" , 		1 );
    ListBox->AddItem("sub2.bmp", "item-2-1-0-1" , 		1 );
    ListBox->AddItem("sub2.bmp", "item-2-3-0-1 (more)" ,	1 );
    ListBox->AddItem("buggy.bmp", "item-2-0-0-2" , 		2 );
    ListBox->AddItem("sub2.bmp", "item-2-0-1-2 (more)" ,	2 );
    ListBox->AddItem("sub2.bmp", "item-2-0-0-3" , 		3 );
    ListBox->AddItem("sub2.bmp", "item-2-0-1-3" , 		3 );

  ListBox->SetupItemData();
}

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

class TMyApp : public TApplication

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
{
  public:
    TMyApp() : TApplication() {}
    ~TMyApp();

  protected:
    TMDIClient *Client;

    // Override methods of TApplication
    void InitInstance();
    void InitMainWindow();

    // user defined menus
    void CmDialogTest();
    void CmDialogTest1();

  DECLARE_RESPONSE_TABLE(TMyApp);
};

DEFINE_RESPONSE_TABLE1(TMyApp, TApplication)
  EV_COMMAND(CM_DIALOGTEST, CmDialogTest),
  EV_COMMAND(CM_DIALOGTEST1, CmDialogTest1),
END_RESPONSE_TABLE;

//------------------------------------------------------------------------
void 	TMyApp::InitMainWindow()
//------------------------------------------------------------------------
{
  // Construct the decorated frame window

  TDecoratedMDIFrame* frame =
	new TDecoratedMDIFrame(WINDOWTITLE,
			       0,
			       *(Client = new TMDIClient),
			       TRUE);	// statusbar menu-tracking

  // Construct a status bar
  TStatusBar* sb = new TStatusBar(frame, TGadget::Recessed);

  // Insert the status bar and control bar into the frame
  frame->Insert(*sb, TDecoratedFrame::Bottom);

  EnableCtl3d();	// ctl3d.dll !!!

  // Set the main window and its menu
  SetMainWindow(frame);
  GetMainWindow()->SetMenuDescr(TMenuDescr("COMMANDS",1,0,1,0,0,0));
}

//------------------------------------------------------------------------
void	TMyApp::InitInstance()
//------------------------------------------------------------------------
{
  TApplication::InitInstance();
}

//------------------------------------------------------------------------
void 	TMyApp::CmDialogTest()
//------------------------------------------------------------------------
{
  THDialog( GetMainWindow(), "HIERDIALOG").Execute();
}

//------------------------------------------------------------------------
void 	TMyApp::CmDialogTest1()
//------------------------------------------------------------------------
{
  TH1Dialog( GetMainWindow(), "HIERDIALOG").Execute();
}

//------------------------------------------------------------------------
	TMyApp::~TMyApp()
//------------------------------------------------------------------------
{
}

//************************************************************************
int 	OwlMain(int /*argc*/, char* /*argv*/ [])
//************************************************************************
{
  return TMyApp().Run();
}

